-- 广播公告：非滚动，3秒限时的公告板
Lua_BulletinBoardSecWindow = class("Lua_BulletinBoardSecWindow", Lua_Window);
function Lua_BulletinBoardSecWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BulletinBoardSecWindow";
	self.isModel = false;
	self.showClose = false;
	self.layer = 6500;
end

function Lua_BulletinBoardSecWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isRunning = false;
	self.list = Array();

	self.bgSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_title_08", 0, 0, 876, 38);
	self.bgSp:setDepth(5);

	self.txt = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 21);
	self.txt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.txt.pivot = UIWidget.Pivot.Center;
	self.txt.clickScale = false;
	self.txt:setDepth(6);
	self.txt:addClickFuntion(self, self.onClickTxt);

	self.boardShowTime = Lua_CommonUtil.getCommonConfig("bulletinBoard_showTime", 1);
	if self.boardShowTime == nil then
		self.boardShowTime = 3;
	end

	self:onSceneChange();
	self:addLuaEvent("SCENE_CHANGE", self, self.onSceneChange);
end

function Lua_BulletinBoardSecWindow:showWin(param)
	self:superCall("showWin", param);

	for i = 1, param.circle do
		self.list:add(param);
	end
	self:sortList();

	while self.list:getSize() > 20 do
		self.list:shift();
	end

	if self.isRunning == nil or self.isRunning == false then
		self:updateData();
	end

	-- 判断是否采用广播样式
	if param.display_horn ~= nil and param.display_horn == 1 then
		self.labaSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_icon_laba", 0, 0, 0, 0);
		self.labaSp:setDepth(5);
		self.labaSp:setLocation(-self.txt.width / 2 - 60, 0, 0);

		self.labaEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hanhua", "gui_hanhua", -2010, -412);
		self.labaEff:setLoop(true);
		self.labaEff:setSacle(200, 200, 200);
		self.labaEff:SetRenderQueue(self.labaSp, 1, 2);
	end
end

function Lua_BulletinBoardSecWindow:onSceneChange()
	if DataCenter.answerData.bInAnswerScene == true then
		LuaUtil.setObjPos(self.content, 0, MainWinDefine.V_height / 2 - 85, 0);
	else
		LuaUtil.setObjPos(self.content, 0, MainWinDefine.V_height / 2 - 85, 0);
	end
end

function Lua_BulletinBoardSecWindow:onClickTxt(go)
	if self.showData ~= nil then
		local urlStr = self.txt:getUrlByMousePos();
		if urlStr ~= nil then
			Lua_ChatUtil.urlClickHandle(urlStr, self.showData);
		end
	end
end

function Lua_BulletinBoardSecWindow:sortList()
	local count = self.list:getSize();
	for i = 1, count do
		for j = i + 1, count do
			local a1 = self.list[i].priority;
			local b1 = self.list[j].priority;
			if a1 > b1 then
				local temp = self.list[i];
				self.list[i] = self.list[j];
				self.list[j] = temp;
			end
		end
	end
end

function Lua_BulletinBoardSecWindow:updateData()
	if self.list:getSize() > 0 then
		self.showData = self.list:shift();
		self.txt.text = self.showData.content;

		self.runeTime = self.boardShowTime;
		self.curTime = getTime();
		self:startTimer();
	else
		self:hide();
	end
end

function Lua_BulletinBoardSecWindow:startTimer()
	if self.isRunning ~= true then
		self.isRunning = true;
		Lua_CommonUtil.addTimer("Lua_BulletinBoardSecWindow", 0.02, self, self.onShowNextInfo);
	end
end

function Lua_BulletinBoardSecWindow:onShowNextInfo()
	local num = getTime();
	self.runeTime = self.runeTime - (num - self.curTime);
	self.curTime = num;
	if self.runeTime <= 0 then
		self:updateData();
	end
end

function Lua_BulletinBoardSecWindow:endTimer()
	if self.isRunning == true then
		self.isRunning = false;
		Lua_CommonUtil.removeTimer(self, self.onShowNextInfo);
	end
end

function Lua_BulletinBoardSecWindow:dispose()
	if self.list ~= nil then
		self.list:dispose();
		self.list:clear();
		self.list = nil;
	end
	if self.bgSp ~= nil then
		self.bgSp:dispose();
		self.bgSp = nil;
	end
	if self.txt ~= nil then
		self.txt:dispose();
		self.txt = nil;
	end
	if self.labaSp ~= nil then
		self.labaSp:dispose();
		self.labaSp = nil;
	end
	if self.labaEff ~= nil then
		self.labaEff:dispose();
		self.labaEff = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end