Lua_ChatFaceWindow = class("Lua_ChatFaceWindow", Lua_Window);
function Lua_ChatFaceWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ChatFaceWindow";
	self.showClose = false;
	self.showBg = false;
	self.startX = 0;
	self.isModel = true;
	self.blackAlpha = 0.01;
	self.isClickClose = true;
end
function Lua_ChatFaceWindow:buildShowItem()
	self:superCall("buildShowItem");
end
function Lua_ChatFaceWindow:showWin(param)
	local offsetX = param.offsetX;
	local offsetY = param.offsetY;

	self.bg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_widget_001", offsetX, offsetY, 664, 329);
	self.bg:setDepth(1);

	self.owner = param.owner;
	self.callBack = param.callBack;

	self.faces = Array();
	for i=1,Lua_ChatUtil.MAX_FACE_INDEX  do
		local index = i;
		local str = tostring(index);
		if string.len(str) == 1 then
			str = "0"..str;
		end
		local lx = (index -1) % 8;
		local ly = math.floor((index -1) / 8);
		local face = UICreate.createUIAtlasImage(self.content, "icon_atlas_2", "ui_chat_bq_"..str, 0, 0, 70, 70);
		face.name = str;
		face:setLocation(offsetX-270 + lx * 78, offsetY + 110 + ly * 75 * -1, 0);
		face:setDepth(2);
		face:addClickFuntion(self,self.onFaceClick);
		self.faces:add(face);
	end
end
function Lua_ChatFaceWindow:onFaceClick(go)
	if self.owner ~= nil and self.callBack ~= nil then
		self.callBack(self.owner, go.name);
	end
	self:hide();
end
function Lua_ChatFaceWindow:hide()
	self.owner = nil;
	self.callBack = nil;
	self:superCall("hide");
end