checkRequire("Lua_ChatHeadLeftItem");
checkRequire("Lua_ChatHeadRightItem");
checkRequire("Lua_ChatDragContainer");
checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatChanelItem");
Lua_ChatWindow = class("Lua_ChatWindow", Lua_Window);
function Lua_ChatWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChatWindow";
	self.skinName = "ChatWindow_skin";
	self.isModel = false;
	self.blackAlpha = 0.01;

	self.startX = 0;
	self.lastSendTime = 0;
	self.itemList = Array();
end

function Lua_ChatWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	-- self.content.transform.localPosition = Vector3(- MainWinDefine.V_width / 2, 0, 0);
	LuaUtil.setObjPos(self.content, -MainWinDefine.V_width / 2, 0, 0);
end

function Lua_ChatWindow:showWin(param)
	self:superCall("showWin", param);

	self.toindex = nil;
	if type(param) == "table" and param.openIdx ~= nil then
		self.toindex = param.openIdx;
	elseif type(param) == "number" then
		self.toindex = param;
	end

	if self.toindex ~= nil and self.btnList ~= nil and self.btnList:getSize() >= self.toindex then
		self:onButtonListClick(self.toindex, true);
	end
end

function Lua_ChatWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.tempState = 0;
	self.rightBg.clickScale = false;
	self.rightBg:addClickFuntion(self,self.onBgClick);

	local uvRect = Vector4(0, 0, 1, 0.99);
	self.rightBg:setUVRect(uvRect);

	self.faceBtn:addClickFuntion(self, self.onFaceClick);
	self.soundBtn:addClickFuntion(self, self.onSoundClick);
	self.soundBtn:addMouseUpFuntion(self, self.onSoundUpClick);
	self.subBtn:addClickFuntion(self, self.onSendClick);
    self.rankSp:addClickFuntion(self, self.openRankWindow);

	if getShowTips() == false or getLanType() == 1 or DataCenter.chatData.bVoiceShield == true then
		self.soundBtn:setEnable(false);
	end

	self.btnClose.alpha = 0.02;

	self.setBtn:addClickFuntion(self, self.onSetClick);
	self.labaBtn:addClickFuntion(self, self.onLabaClick);

	self:addLuaEvent("ADD_CHAT_MSG", self, self.onChatUpdate);
	self:addLuaEvent("CHAT_CHANEL_CHANGE", self, self.onButtonListClick);
    self:addLuaEvent("CHAT_GANGANSWER_CHANGE", self, self.updataGangAnswerInfo);
    self:addLuaEvent("CHAT_SHOW_ITEM_UPDATE", self, self.onChatShowItemChange);
	self:addCSharpEvent("VOICE_DONE", self, self.onVoiceDown);
	self:onChatShowItemChange();

	self.defaultMsg = LanUtil.getValue(120207);
	self.msgText.defaultText = self.defaultMsg;
	self.msgText.text = "";

	local len = DataCenter.chatData.maxMsgLen;
    self.msgText.characterLimit = len;
    self.msgText.maxLineCount = 1;

	local btnNames = Array();
	btnNames:add(LanUtil.getValue(120205));
	btnNames:add(LanUtil.getValue(120202));
	btnNames:add(LanUtil.getValue(120203));
	btnNames:add(LanUtil.getValue(120204));
	btnNames:add(LanUtil.getValue(120230));
	btnNames:add(LanUtil.getValue(120235));
	if DataCenter.chatData.showKuaFu == 1 then
		btnNames:add(LanUtil.getValue(120233));
	end

	self.btnList = Array();
	for i = 1, btnNames:getSize() do
		local btn = Lua_ChatChanelItem.new(self.content);
		btn:setData(btnNames[i], i);
		btn:setLocation(53, - 80 * (i - 1) + 300,0);
		btn:setDepth(5);
		self.btnList:add(btn);
	end

	self.dragContainer = Lua_ChatDragContainer.new(self.content,1, Vector4(230, -286, 475, 630), 440);
	self.dragContainer:setLocation(152, 327, 0);
	self.dragContainer.onMoveingOwner = self;
	self.dragContainer.onMoveingCallBack = self.onMoveingCallBack;
	self.dragContainer.addNum = -30;

	local chatData = DataCenter.chatData;
    self.txtContaner1 = UICreate.createGameObject(self.content, 0, 0, 0);
    self.txtContaner1.name = "txtContaner1";
    self.txtPanel1 = self.txtContaner1:AddComponent(typeof(UIPanel));  
    self.txtPanel1.cullWhileDragging = false;
    self.txtPanel1.softBorderPadding = false;

    self.txtContaner2 = UICreate.createGameObject(self.txtContaner1, 0, 0, 0);
    self.txtContaner2.name = "txtContaner2";
    self.txtPanel2 = self.txtContaner2:AddComponent(typeof(UIPanel));  
    self.txtPanel2.cullWhileDragging = false;
    self.txtPanel2.softBorderPadding = false;

    self.infoTxt = UICreate.createLabel(self.txtContaner2,"0",578,-258,170,25,20);
    self.infoTxt.pivot = UIWidget.Pivot.Right;
    self.infoTxt:setLocation(573,-257,0);

    if self.toindex ~= nil and self.btnList:getSize() >= self.toindex then
    	self:onButtonListClick(self.toindex, true);
    else
	    local clist = chatData:getChannelMsgList(Lua_ChatData.CHANEL_WORLD);
	    if clist == nil or clist:getSize() == 0 then
	    	self:onButtonListClick(1, true);
	    else
	    	self:onButtonListClick(2, true);
	    end
    end
    self.lockBg:addClickFuntion(self,self.onLockBgClick);

    WindowMananger.getInstance():resetChildParent(self.txtContaner1.transform);
    self:setLockState(chatData.isLock);
end

function Lua_ChatWindow:openRankWindow()
    Lua_WindowUtil.openWin("Lua_GangAnswarRankWindow",WinParam.ACTION_OPEN,nil);
end

function Lua_ChatWindow:onMoveingCallBack(val)
	if val < 5 and val > -5 then
		return;
	end

	if val > 0 then
		self:setLockState(0);
	else
		self:setLockState(1);
	end
end

function Lua_ChatWindow:onChatShowItemChange(o)
	local showType = DataCenter.chatData.showType;
	local vitem = DataCenter.chatData.showItemData;
	if showType ~= 0 
		and self.btnSelected ~= nil and self.btnSelected ~= 1 and self.btnSelected ~= 5 then
		if showType == 1 then
			if vitem.index ~= self.curItemIndex or self.curItemId ~= vitem.id then
				self.curItemIndex = vitem.index;
				self.curItemId = vitem.id;
				self.msgText.text = "["..vitem.name.."]";
			end
		elseif showType == 2 then
			self.msgText.text = "["..LanUtil.getValue(128811).."]";
		end
	end
end

function Lua_ChatWindow:updataGangAnswerInfo()
    self.gangData=DataCenter.chatData.gangData;
    if self.gangData == nil or self.btnSelected ~= 3 then
        return;
    end
        if self.gangData.state == 3 then
            self.gangBg:setAltas("common_atlas_1", "ui_common_tips_d");
            self.gangBg:SetDimensions(460, 135);
            self.rankSp:setEnable(false)
            self.tipsTxt.text = LanUtil.getValue(128403);
            self.timeTxt.uiwidget.gameObject:SetActive(false);
            self.titleTxt.text=LanUtil.formateStr(LanUtil.getValue(128402),tostring(TimeTransform.getInstance():transSeconds6(math.ceil(DataCenter.chatData.gangTime), false, true)));
            local size = self.titleTxt:lastPrintedSize(self.titleTxt.text)
            self.tipsTxt:setLocation(152, 341 - size.y - 10);
            self.rankSp:setLocation(175, 288 - size.y - 10);
            self.timeTxt:setLocation(572, 272 - size.y -10);
            self.gangBg:SetDimensions(464, 103 + size.y +10);
            self.dragContainer:updateClipRegion(Vector4(230, -230, 475, 530 - size.y -10));
            self.dragContainer:setLocation(152, 196 - (size.y +10)/2);
            self.tempState = self.gangData.state;
        else
            self.tempState=self.gangData.state;
            self.rankSp:setEnable(true);
            self.gangBg:setAltas("common_atlas_1", "ui_common_tips_d");
            self.tipsTxt.text=LanUtil.getValue(128405);
            self.timeTxt.uiwidget.gameObject:SetActive(true);
            self.titleTxt.text=LanUtil.formateStr(LanUtil.getValue(128404),tostring(self.gangData.cur_stage),tostring(self.gangData.topic_desc));
            local size = self.titleTxt:lastPrintedSize(self.titleTxt.text)
            self.tipsTxt:setLocation(152, 341 - size.y - 10);
            self.rankSp:setLocation(175, 288 - size.y - 10);
            self.timeTxt:setLocation(572, 272 - size.y -10);
            self.gangBg:SetDimensions(464, 103 + size.y +10);
            self.dragContainer:updateClipRegion(Vector4(230, -230, 475, 530 - size.y -10));
            self.dragContainer:setLocation(152, 196 - (size.y +10)/2);
            
        end
        if self.gangData.state == 0 then
            self.dragContainer:updateClipRegion(Vector4(230, -286, 475, 630))
            self.dragContainer:setLocation(152,327,0);
            self.dragContainer.addNum = -30;
            self.dragContainer:updateChildPos();
            self.gangObj:SetActive(false);
        end
    if self.gangData.state == 1 then
        self.timeTxt.text=LanUtil.formateStr(LanUtil.getValue(128406),tostring(math.ceil(DataCenter.chatData.gangTime)));
    elseif self.gangData.state == 2 then
        self.timeTxt.text=LanUtil.formateStr(LanUtil.getValue(128407),tostring(math.ceil(DataCenter.chatData.gangTime)));
    elseif self.gangData.state == 3 then
       
    end
end

function Lua_ChatWindow:onButtonListClick(val)
	self.btnSelected = val;
	self:setLockState(0);
	local chatData = DataCenter.chatData;
	chatData.selectedIndex = val;
	chatData.selectedChanel = self:getChannel();
	local channel = self:getShowChannel();
	local list = chatData:getChannelMsgList(channel);
    local sceneId = DataCenter.roleData.sceneId;

    if sceneId == 30101 and chatData.selectedIndex==3 and DataCenter.chatData.gangData~=nil and DataCenter.chatData.gangData.state~=0 then
        self.dragContainer:updateClipRegion(Vector4(230, -223, 475, 480))
        self.dragContainer:setLocation(145,202,0);
        self.dragContainer.addNum = -200;
        self.dragContainer:updateChildPos();
        self.gangObj:SetActive(true);
        self:updataGangAnswerInfo();
    else
        self.dragContainer:updateClipRegion(Vector4(230, -286, 475, 630))
        self.dragContainer:setLocation(153,327,0);
        self.dragContainer.addNum = -30;
        self.dragContainer:updateChildPos();
        self.gangObj:SetActive(false);
    end
	self.dragContainer:updateChatList(list, chatData.isLock == 0);
	if chatData.chatTypeRedDotInfo[channel] ~= nil and chatData.chatTypeRedDotInfo[channel] == true then
		chatData.chatTypeRedDotInfo[channel] = false;
		Lua_MsgUtil.callFunc("UPDATE_MINICHAT_REDDOT", channel);
	end

	for i=1,self.btnList:getSize() do
		self.btnList[i]:setSelected(i == val);
	end
	if self.btnSelected == 1 or self.btnSelected == 5 then
		self.infoChTxt:setEnable(true);
		self.bobj:SetActive(false);
	else
		self.infoChTxt:setEnable(false);
		self.bobj:SetActive(true);
	end
	if self.btnSelected ~= 3 then
		self.dragContainer:updateClipRegion(Vector4(230, -286, 475, 630));
        self.dragContainer:setLocation(152, 327, 0);
    end
	self:onChatShowItemChange();
end

function Lua_ChatWindow:onChatUpdate(val)
	local chatData = DataCenter.chatData;
	local c = val.channel;
	if (c == Lua_ChatData.CHANEL_WORLD and self.btnSelected == 2)
		or (c == Lua_ChatData.CHANEL_FACTION and self.btnSelected == 3)
		or (c == Lua_ChatData.CHANEL_TEAM and self.btnSelected == 4)
		or (c == Lua_ChatData.CHANEL_SYSTEM and self.btnSelected == 1) 
		or (c == Lua_ChatData.CHANEL_WORLD_KUAFU and self.btnSelected == 6) 
		or (c == Lua_ChatData.CHANEL_QUYU and self.btnSelected == 7) then
		self.dragContainer:addNewChat(val, 30, chatData.isLock == 0);
		if chatData.isLock == 1 then
			local newNum = chatData:getChanleNewMsgNum(c);
			if newNum > 0 then
				self.infoTxt:setEnable(true);
				self.infoTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.formateStr(LanUtil.getValue(120220), tostring(newNum)).."[-]";
			else
				self.infoTxt:setEnable(false);
			end
		end
		
		if chatData.chatTypeRedDotInfo[c] ~= nil and chatData.chatTypeRedDotInfo[c] == true then
			chatData.chatTypeRedDotInfo[c] = false;
			Lua_MsgUtil.callFunc("UPDATE_MINICHAT_REDDOT", c);
		end
	end
end

function Lua_ChatWindow:getChannel()
	if self.btnSelected == 1 or self.btnSelected == 2 then
		return Lua_ChatData.CHANEL_WORLD;
	elseif self.btnSelected == 3 then
		return Lua_ChatData.CHANEL_FACTION;
	elseif self.btnSelected == 4 then
		return Lua_ChatData.CHANEL_TEAM;
	elseif self.btnSelected == 5 then
		return Lua_ChatData.CHANEL_CREATE_TEAM;
	elseif self.btnSelected == 6 then
		return Lua_ChatData.CHANEL_WORLD_KUAFU;
	elseif self.btnSelected == 7 then
        return Lua_ChatData.CHANEL_QUYU;
	end
end

function Lua_ChatWindow:getShowChannel()
	if self.btnSelected == 1 then
		return Lua_ChatData.CHANEL_SYSTEM;
	elseif self.btnSelected == 2 then
		return Lua_ChatData.CHANEL_WORLD;
	elseif self.btnSelected == 3 then
		return Lua_ChatData.CHANEL_FACTION;
	elseif self.btnSelected == 4 then
		return Lua_ChatData.CHANEL_TEAM;
	elseif self.btnSelected == 5 then
		return Lua_ChatData.CHANEL_CREATE_TEAM;
	elseif self.btnSelected == 6 then
		return Lua_ChatData.CHANEL_WORLD_KUAFU;
    elseif self.btnSelected == 7 then
        return Lua_ChatData.CHANEL_QUYU;
	end
end

function Lua_ChatWindow:onBgClick(go)
end

function Lua_ChatWindow:onFaceClick(go)
	local p = {};
	p.offsetX = - MainWinDefine.V_width / 2 + 460;
	p.offsetY = -90;
	p.owner = self;
	p.callBack = self.onFaceSelected;
	Lua_WindowUtil.openWin("Lua_ChatFaceWindow", nil, p);
end

function Lua_ChatWindow:canSendToChanal(tips)
	local c = self:getChannel();
	if c == Lua_ChatData.CHANEL_FACTION then
		if DataCenter.roleData.leagueId == 0 then
			if tips then
				OperateAlert.show(LanUtil.getValue(120223));
			end
			return false;
		end
	end
	return true;
end

function Lua_ChatWindow:onFaceSelected(val)
	if self.msgText.text == self.defaultMsg then
		self.msgText.text = "/"..val;
	else
		self.msgText.text = self.msgText.text.."/"..val;
	end
end

function Lua_ChatWindow:onSoundClick(go)
	if self:canSendToChanal(true) == false then
		return;
	end
	local showPos = Vector3(- MainWinDefine.V_width / 2 + 370, 0,0);
	Lua_WindowUtil.openWin("Lua_ChatSoundWindow", WinParam.ACTION_OPEN,showPos);
	ChatRecordSound.getInstance():startRecord();
end

function Lua_ChatWindow:onSoundUpClick(go)
	Lua_WindowUtil.openWin("Lua_ChatSoundWindow", WinParam.ACTION_CLOSE);
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.soundBtn.mainContent.transform:InverseTransformPoint(screenpos);
	
	if mousePosition.x > 0 and mousePosition.x < 50 and mousePosition.y > - 25 and mousePosition.y < 25 then
		self.isCancel = false;
	else
		self.isCancel = true;
	end
	ChatRecordSound.getInstance():stopRecord();
end

function Lua_ChatWindow:onVoiceDown(o)
	if self.isCancel == false then
		local socketType = 2;
		if self:getChannel() == Lua_ChatData.CHANEL_QUYU then
			socketType = 3;
		end
		if self:getChannel() == Lua_ChatData.CHANEL_WORLD_KUAFU then
            socketType = 1;
        end
		if CommonUtil.isApplePlatform == false then
			ChatUtil.sendVoiceMsg(self:getChannel(), "", socketType);
		else
			Lua_ChatUtil.sendVoiceMsg(self:getChannel(), "", socketType);
		end
	end
	ChatRecordSound.getInstance():clear();
end

function Lua_ChatWindow:onSendClick(go)
	if self:canSendToChanal(true) == false then
		return;
	end
	local str = self.msgText.text;
	if self.defaultMsg == str or string.len(str) == 0 then
		OperateAlert.show(LanUtil.getValue(120216));
		return;
	end
	if str == "A6D2D735" then
		Lua_WindowUtil.openWin("Lua_DebugWindow");
		return;
	end
	if str == "BA82821A" then
		MsgUtil.callFunc("SHOW_LOG_CHANGE");
		return;
	end
	if str == "65FACA33" then
		DataCenter.showVersion = true;
		return;
	end
	if str == "5BEB2EC8" then
		MsgUtil.callFunc("SHOW_FPS");
		return;
	end
	self.lastSendTime = getTime();
	local socketType = 2;
	if self:getChannel() == Lua_ChatData.CHANEL_QUYU then
		socketType = 3;
	end
	if self:getChannel() == Lua_ChatData.CHANEL_WORLD_KUAFU then
        socketType = 1;
    end
	if self:getChannel() == Lua_ChatData.CHANEL_TEAM 
		and DataCenter.chatData.showKuaFu == 1 then
		local scd = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if scd.team_chat_kuafu == 1 then
			socketType = 3;
		end
	end
	
	if DataCenter.roleData.permission == 8 then
		local rs = str;
		Lua_ChatUtil.sendWordMsg(self:getChannel(), rs, "", false, socketType);
	else
		local vitem = DataCenter.chatData.showItemData;
		if DataCenter.chatData.showType ~= 0 and vitem ~= nil then
			local showName = nil;
			if DataCenter.chatData.showType == 1 then
				showName = "["..vitem.name.."]";
			else
				showName = "["..LanUtil.getValue(128811).."]";
			end
			local s = string.gsub(showName, "%[", "%%%[");
			s = string.gsub(s, "%(", "%%%(");
			s = string.gsub(s, "%)", "%%%)");
			s = string.gsub(s, "%]", "%%%]");
			s = string.gsub(s, "%*", "%%%*");
			str = string.gsub(str, s, "〖〗");
		end
		local rs = Lua_ChatUtil.replaceChatMsg(str);
		local canSend = Lua_ChatUtil.checkSendMsg(rs);
		if canSend == 1 or canSend == 2 then
			OperateAlert.show(LanUtil.getValue(120231));
		else
            if self:getChannel() == Lua_ChatData.CHANEL_FACTION 
            	and DataCenter.roleData.sceneId==30101 
            	and self.gangData ~= nil and self.gangData.state == 1 then
                Lua_ChatUtil.sendActivityWordMsg(self:getChannel(), str, "", true, 1);
            else
            	Lua_ChatUtil.sendWordMsg(self:getChannel(), rs, "", true, socketType);
            end
		end
	end
	self.curItemIndex = nil;
	self.curItemId = nil;
	self.msgText.defaultText = self.defaultMsg;
	self.msgText.text = "";
end

function Lua_ChatWindow:sendQuYuOnLowVerion(str,channel)
	local cmd = ProtoPublic_pb.Proto10400004();
    cmd.channel = channel;
    cmd.type = 1;
    cmd.wcontent = str;
    sendMsg(10400004, cmd);
end

function Lua_ChatWindow:onSetClick(go)
	Lua_WindowUtil.openWin("Lua_ChatSettingWindow");
end

function Lua_ChatWindow:onLabaClick(go)
	Lua_WindowUtil.openWin("Lua_LaBaInputWindow");
end

function Lua_ChatWindow:onLockBgClick(go)
	local chatData = DataCenter.chatData;
	if chatData.isLock == 0 then
		self:setLockState(1);
	else
		self:setLockState(0);
	end
end

function Lua_ChatWindow:setLockState(val)
	local chatData = DataCenter.chatData;
	chatData.isLock = val;
	if chatData.isLock == 0 then
		self.lockTxt.text = LanUtil.getValue(120222);
		self.lockTxt:setLocation(78,-246,0);
		self.lockBg:setAltas("chatPanel_atlas", "ui_chat_widget_g");
		self.infoTxt:setEnable(false);
	else
		self.lockTxt.text = LanUtil.getValue(120221);
		self.lockTxt:setLocation(38,-246,0);
		self.lockBg:setAltas("chatPanel_atlas", "ui_chat_widget_k");
	end
end

function Lua_ChatWindow:dispose()
	DataCenter.chatData.isLock = 0;
	DataCenter.chatData:setChatShowItem(0, nil);

	self:superCall("dispose");
end