-- 广播喇叭：滚屏
checkRequire("Lua_BulletinContent")
Lua_LaBaWindow = class("Lua_LaBaWindow", Lua_Window);
function Lua_LaBaWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LaBaWindow";
	self.isModel = false;
	self.showClose = false;
	self.layer = 6500;
end

function Lua_LaBaWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.RUN_SPEED = 4;
	self._curPos = 0;
	self.isRunning = false;
	self.list = Array();

	LuaUtil.setObjPos(self.content, 0, 275, 0);

	self.bgSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_title_08", 0, 0, 876, 38);
	self.bgSp:setDepth(1);

	self.labaSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_icon_laba", -425, 0, 0, 0);
	self.labaSp:setDepth(2);

	local maskObj = UICreate.createGameObject(self.content);
	local maskPanel = maskObj:AddComponent(typeof(UIPanel));
	maskPanel.clipOffset = Vector2(0, 0);
	maskPanel.clipSoftness = Vector2(2, 2);
	maskPanel.clipping = UIDrawCall.Clipping.SoftClip;
	maskPanel.baseClipRegion = Vector4(0, 0, 800, 55);
	maskPanel.startingRenderQueue = self.depth + 10;
	maskPanel.renderQueue = UIPanel.RenderQueue.StartAt;
	maskPanel.widgetsAreStatic = false;
	maskPanel.anchorOffset = false;
	maskPanel.depth = self.depth + 10;

	self.container = Lua_BulletinContent.new(maskObj);
end

function Lua_LaBaWindow:showWin(param)
	self:superCall("showWin", param);

	for i = 1, param.circle do
		self.list:add(param);
	end
	self:sortList();

	while self.list:getSize() > 20 do
		self.list:shift();
	end

	if self.isRunning == nil or self.isRunning == false then
		self:updateData();
	end
end

function Lua_LaBaWindow:sortList()
	local count = self.list:getSize();
	for i = 1, count do
		for j = i + 1, count do
			local a1 = self.list[i].priority;
			local b1 = self.list[j].priority;
			if a1 > b1 then
				local temp = self.list[i];
				self.list[i] = self.list[j];
				self.list[j] = temp;
			end
		end
	end
end

function Lua_LaBaWindow:updateData()
	if self.list:getSize() > 0 then
		self.container:setText(self.list[1].content);
		self.list:shift();
		self:startTimer();
		self.containerPos = 400;
	else
		self:hide();
	end
end

function Lua_LaBaWindow:startTimer()
	if self.isRunning ~= true then
		self.isRunning = true;
		Lua_CommonUtil.addTimer("Lua_LaBaWindow", 0.02, self, self.onEnterFrame);
	end
end

function Lua_LaBaWindow:onEnterFrame()
	self.containerPos = self.containerPos - self.RUN_SPEED;
	local endPos = math.floor(-400 - self.container:getWidth());
	if self.containerPos <= endPos then
		self:updateData();
	end
end

function Lua_LaBaWindow:endTimer()
	if self.isRunning == true then
		self.isRunning = false;
		Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
	end
end

function Lua_LaBaWindow.Get:containerPos()
	return self._curPos;
end

function Lua_LaBaWindow.Set:containerPos(value)
	self._curPos = value;
	self.container:setLocation(self._curPos, 0);
end

function Lua_LaBaWindow:dispose()
	if self.list ~= nil then
		self.list:dispose();
		self.list:clear();
		self.list = nil;
	end
	if self.bgSp ~= nil then
		self.bgSp:dispose();
		self.bgSp = nil;
	end
	if self.labaSp ~= nil then
		self.labaSp:dispose();
		self.labaSp = nil;
	end
	if self.container ~= nil then
		self.container:dispose();
		self.container = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end